## sail-ocaml 0.19.1+dfsg5

=== Makefile ===
.PHONY: all isail sail install coverage clean asciidoc docker test core-tests c-tests

all: sail

isail: sail

sail:
	dune build --release

install: sail
	dune install

libsail_coverage:
	$(MAKE) -C lib/coverage

# Build binary tarball. The lib directory is very large and not needed
# for running the compiler. TARBALL_EXTRA_BIN can be used to bundle z3.
tarball: sail libsail_coverage
	dune install --relocatable --prefix=_build/tarball/sail
	rm -rf _build/tarball/sail/lib
	cp LICENSE _build/tarball/sail
	cp THIRD_PARTY_FILES.md _build/tarball/sail
	cp -a etc/tarball_extra/. _build/tarball/sail
ifdef TARBALL_EXTRA_BIN
	cp $(TARBALL_EXTRA_BIN) _build/tarball/sail/bin/
endif
	cp lib/coverage/libsail_coverage.a _build/tarball/sail/share/sail/lib/coverage/
	tar czvf _build/sail.tar.gz -C _build/tarball sail

coverage:
	dune build --release --instrument-with bisect_ppx

clean:
	dune clean

asciidoc:
	$(MAKE) -C doc/asciidoc
	cp doc/asciidoc/manual.html manual.html

docker:
	docker build --tag sail:0.1 .
	@echo 'for example: docker run --volume `PWD`:/data/ sail:0.1 --help'

test:
	SAIL_DIR=`pwd` SAIL=`pwd`/sail test/run_tests.sh

core-tests:
	SAIL_DIR=`pwd` SAIL=`pwd`/sail test/run_core_tests.sh

c-tests:
	SAIL_DIR=`pwd` SAIL=`pwd`/sail test/c/run_tests.py

=== sailcov/Makefile ===

sailcov: *.ml dune
	dune build main.exe
	cp -f ../_build/default/sailcov/main.exe sailcov

=== lib/coverage/Makefile ===
libsail_coverage.a: src/*.rs Cargo.toml Makefile
	cargo build --release
	cp target/release/libsail_coverage.a .

=== lib/hol/Makefile ===
LEM_DIR?=$(shell opam config var lem:share)

LEMSRC =  \
  ../../src/gen_lib/sail2_instr_kinds.lem \
  ../../src/gen_lib/sail2_values.lem \
  ../../src/gen_lib/sail2_operators.lem \
  ../../src/gen_lib/sail2_operators_mwords.lem \
  ../../src/gen_lib/sail2_operators_bitlists.lem \
  ../../src/gen_lib/sail2_state_monad.lem \
  ../../src/gen_lib/sail2_state.lem \
  ../../src/gen_lib/sail2_string.lem \
  sail2_prompt_monad.lem \
  sail2_prompt.lem \
  sail2_undefined.lem \

SCRIPTS = sail2_instr_kindsScript.sml sail2_valuesScript.sml sail2_operatorsScript.sml \
  sail2_operators_mwordsScript.sml sail2_operators_bitlistsScript.sml \
  sail2_state_monadScript.sml sail2_stateScript.sml \
  sail2_prompt_monadScript.sml sail2_promptScript.sml sail2_undefinedScript.sml \
  sail2_stringScript.sml

THYS = $(patsubst %Script.sml,%Theory.uo,$(SCRIPTS))

all: sail-heap $(THYS)
all-scripts: $(SCRIPTS)

$(SCRIPTS): $(LEMSRC)
	lem -hol -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $(LEMSRC)

$(THYS) sail-heap: $(SCRIPTS)
	LEM_DIR=$(LEM_DIR) Holmake

# Holmake will also clear out the generated $(SCRIPTS) files
clean:
	Holmake cleanAll

.PHONY: all all-scripts clean

=== lib/isabelle/Makefile ===
THYS = Sail2_instr_kinds.thy Sail2_values.thy Sail2_operators.thy \
  Sail2_operators_mwords.thy Sail2_operators_bitlists.thy \
  Sail2_state_monad.thy Sail2_state.thy Sail2_state_lifting.thy \
  Sail2_prompt_monad.thy Sail2_prompt.thy Sail2_undefined.thy \
  Sail2_string.thy Sail2_concurrency_interface.thy \
  Sail2_concurrency_interface_mwords.thy \
  Sail2_concurrency_interface_bitlists.thy \
  Sail2_monadic_combinators.thy Sail2_undefined_concurrency_interface.thy
EXTRA_THYS = Sail2_state_monad_lemmas.thy Sail2_state_lemmas.thy \
  Sail2_prompt_monad_lemmas.thy \
  Sail2_operators_mwords_lemmas.thy Hoare.thy \
  Sail2_concurrency_interface_lemmas.thy \
  Sail2_monadic_combinators_lemmas.thy \
  Trace_Properties.thy

LEM_ISA_LIB?=$(shell opam config var lem:share)/isabelle-lib

SAIL_RISCV ?= ../../../sail-riscv

.PHONY: all heap-img clean

all: thys

thys: $(THYS)

heap-img: thys $(EXTRA_THYS) ROOT
	@echo 'Please make sure that the "Word_Lib" entry of the AFP (https://www.isa-afp.org/) is installed'
	@echo 'and set up, e.g. by adding its path to "$$ISABELLE_HOME_USER/ROOTS".'
	if [ -z "$(wildcard $(LEM_ISA_LIB)/ROOT)" ]; \
	then echo isabelle-lib directory of Lem not found. Please set the LEM_ISA_LIB environment variable; false; \
	else isabelle build -b -d $(LEM_ISA_LIB) -D . ; \
	fi

manual: heap-img manual/Manual.thy manual/ROOT manual/document/root.tex
	cp output/document/session_graph.pdf manual/document/Sail_session_graph.pdf
	make -C $(SAIL_RISCV) riscv_duopod
	isabelle build -d $(LEM_ISA_LIB) -d . -d $(SAIL_RISCV)/generated_definitions/isabelle -D manual

Sail2_instr_kinds.thy: ../../src/gen_lib/sail2_instr_kinds.lem
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_values.thy: ../../src/gen_lib/sail2_values.lem Sail2_instr_kinds.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_operators.thy: ../../src/gen_lib/sail2_operators.lem Sail2_values.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_operators_mwords.thy: ../../src/gen_lib/sail2_operators_mwords.lem Sail2_operators.thy Sail2_prompt.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_operators_bitlists.thy: ../../src/gen_lib/sail2_operators_bitlists.lem Sail2_operators.thy Sail2_prompt.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_prompt_monad.thy: ../../src/gen_lib/sail2_prompt_monad.lem Sail2_values.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_prompt.thy: ../../src/gen_lib/sail2_prompt.lem Sail2_prompt_monad.thy Sail2_prompt_monad_lemmas.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_undefined.thy: ../../src/gen_lib/sail2_undefined.lem Sail2_prompt.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_undefined_concurrency_interface.thy: ../../src/gen_lib/sail2_undefined_concurrency_interface.lem Sail2_concurrency_interface.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_state_monad.thy: ../../src/gen_lib/sail2_state_monad.lem Sail2_values.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_state.thy: ../../src/gen_lib/sail2_state.lem Sail2_prompt.thy Sail2_state_monad.thy Sail2_state_monad_lemmas.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_state_lifting.thy: ../../src/gen_lib/sail2_state_lifting.lem Sail2_prompt.thy Sail2_state.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_string.thy: ../../src/gen_lib/sail2_string.lem Sail2_operators_mwords.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_concurrency_interface.thy: ../../src/gen_lib/sail2_concurrency_interface.lem Sail2_string.thy Sail2_values.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_concurrency_interface_mwords.thy: ../../src/gen_lib/sail2_concurrency_interface_mwords.lem Sail2_concurrency_interface.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_concurrency_interface_bitlists.thy: ../../src/gen_lib/sail2_concurrency_interface_bitlists.lem Sail2_concurrency_interface.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

Sail2_monadic_combinators.thy: ../../src/gen_lib/sail2_monadic_combinators.lem Sail2_concurrency_interface.thy Sail2_values.thy
	lem -isa -outdir . -auxiliary_level none -lib ../../src/lem_interp -lib ../../src/gen_lib $<

clean:
	-rm $(THYS)

=== old/power/Makefile ===
SAIL:=../src/sail.native
LEM:=../../lem/lem

SOURCES:=power.sail ../lib/regfp.sail power_regfp.sail


all: power.lem power.ml power_embed.lem

power.lem: $(SOURCES)
	$(SAIL) -lem_ast -o power $(SOURCES)

power.ml: power.lem ../src/lem_interp/interp_ast.lem
	$(LEM) -ocaml -lib ../src/lem_interp/ $<


power_embed.lem: $(SOURCES)
# also generates power_embed_sequential.lem, power_embed_types.lem, power_toFromInterp.lem
	$(SAIL) -lem -lem_lib Power_extras_embed -o power $(SOURCES)

clean:
	rm -f power.lem power.ml
	rm -f power_embed*.lem power_toFromInterp.lem

######################################################################
ETCDIR=../etc

apply_header:
	headache -c $(ETCDIR)/headache_config -h $(ETCDIR)/power_header *.sail
.PHONY: apply_header

######################################################################
IDLPOWER=../../../rsem/idl/power

pull_from_idl:
	cp -a $(IDLPOWER)/generated/power.sail ./
# 	cp -a $(IDLPOWER)/generated/*.lem ./
# 	cp -a $(IDLPOWER)/generated/power.ml ./
# 	cp -a $(IDLPOWER)/generated/*.txt ./
	cp -a $(IDLPOWER)/extras/*.sail ./
	cp -a $(IDLPOWER)/extras/*.lem ./
	mkdir -p gen
	cp -a $(IDLPOWER)/generated/*.gen gen/
	cp -a $(IDLPOWER)/*.hgen gen/
	$(MAKE) apply_header
.PHONY: pull_from_idl

=== old/x86/Makefile ===
SAIL=../src/sail.native
LEM:=../../lem/lem

SOURCES=../lib/regfp.sail x64.sail

all: x86.lem x86.ml x86_embed.lem

x86.lem:
	$(SAIL) -lem_ast -o x86 $(SOURCES)

x86.ml: x86.lem ../src/lem_interp/interp_ast.lem
	$(LEM) -ocaml -lib ../src/lem_interp/ $<

x86_embed.lem: $(SOURCES)
# also generates x86_embed_sequential.lem, x86_embed_types.lem, x86_toFromInterp.lem
	$(SAIL) -lem -lem_lib X86_extras_embed -o x86 $(SOURCES)

clean:
	rm -f x86.lem x86.ml
	rm -f x86_embed*.lem x86_toFromInterp.lem

=== test/isabelle/Makefile ===
LEM_ISA_LIB?=$(shell opam config var lem:share)/isabelle-lib
ifeq ($(wildcard $(LEM_ISA_LIB)/ROOT),)
$(error isabelle-lib directory of Lem not found. Please set the LEM_ISA_LIB environment variable)
endif

SAIL_ISA_LIB = ../../lib/isabelle
CHERI_DIR ?= ../../../sail-cheri-mips/cheri
AARCH64_DIR ?= ../../aarch64
TGTS = run_cheri.native run_aarch64.native
SESSION_DIRS = -d $(LEM_ISA_LIB) -d $(SAIL_ISA_LIB) -d $(CHERI_DIR) -d $(AARCH64_DIR) -d .

.PHONY: all clean

all: $(TGTS)

%.native: %.ml elf_loader.ml
	ocamlbuild -use-ocamlfind -pkg lem -pkg linksem -pkg num -pkg unix $@

run_cheri.native: cheri_export.ml
run_aarch64.native: aarch64_export.ml

cheri_export.ml: Cheri_code.thy
	make -C $(CHERI_DIR) Cheri.thy
	isabelle build -c $(SESSION_DIRS) Sail-CHERI-Code

aarch64_export.ml: Aarch64_code.thy
	make -C $(AARCH64_DIR) Aarch64.thy
	isabelle build -c $(SESSION_DIRS) Sail-AArch64-Code

clean:
	-ocamlbuild -clean
	-rm -f cheri_export.ml
	-rm -f aarch64_export.ml

=== debian/changelog ===
sail-ocaml (0.19.1+dfsg5-1) unstable; urgency=medium

  * Initial release. (Closes: #1065419)

 -- Bo YU <vimer@debian.org>  Tue, 10 Jun 2025 17:36:25 +0800

=== debian/control ===
Source: sail-ocaml
Priority: optional
Section: ocaml
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Bo YU <vimer@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 ocaml-dune,
 dh-ocaml (>= 1.2),
 liblinenoise-ocaml-dev,
 libdune-ocaml-dev,
 libbase64-ocaml-dev,
 libbisect-ppx-ocaml-dev,
 menhir,
 libmenhir-ocaml-dev,
 ott-tools,
 libbiniou-ocaml-dev,
 libpprint-ocaml-dev,
 ocaml-odoc,
 libyojson-ocaml-dev,
 libnum-ocaml-dev,
 libzarith-ocaml-dev,
 libomd-ocaml-dev,
 lem,
 liblem-ocaml-dev,
 liblinksem-ocaml-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/rems-project/sail
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/sail-ocaml.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/sail-ocaml
Description: language describes the instruction semantics of processors
 Sail is a language for describing the instruction-set
 architecture (ISA) semantics of processors. Sail aims to provide a
 engineer-friendly, vendor-pseudocode-like language for describing
 instruction semantics. It is essentially a first-order imperative
 language, but with lightweight dependent typing for numeric types and
 bitvector lengths, which are automatically checked using Z3. It has
 been used for several papers, available from
 http://www.cl.cam.ac.uk/~pes20/sail/

Package: libsail-ocaml-dev
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${ocaml:Depends},
Suggests:
 ocaml-findlib
Provides: ${ocaml:Provides}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains sail libraries files.

Package: sail-ocaml
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${ocaml:Depends},
 libsail-ocaml-dev (= ${binary:Version}),
Suggests:
 ocaml-findlib
Provides: ${ocaml:Provides}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 Tools and OCaml support files for the Sail language.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export LEMLIB=/usr/share/lem/library

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

execute_after_dh_auto_install:
	# remove these non documentation files for sail itself
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/lib/hol/.gitignore
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/lib/isabelle/.gitignore
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/LICENSE
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/lib/isabelle/document
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/lib/isabelle/manual
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/THIRD_PARTY_FILES.md
	rm -rf $(CURDIR)/debian/tmp/usr/share/sail/lib/sail.tex

override_dh_ocaml:
	dh_ocaml --nodefined-map=libsail-ocaml-dev:Base64__,Base64__Unsafe,Base64,Omd_lexer_fs,Omd_backend,Omd_parser,Omd_lexer,Html_characters,Omd,Omd_representation,Omd_xtxt,Omd_utils,Omd_html

override_dh_dwz:
	dh_dwz --no-dwz-multifile

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg.*$//,repacksuffix=+dfsg,compression=xz \
https://github.com/rems-project/sail/tags .*/archive/.*/(\d+(?:\.\d+)+)\.tar\.gz
